# Reading a file from the host PC

## Description

This is a simple BASIC program to read a file from the user's host PC and print it on the P2. By changing one line you can have it read the file from an SD card instead. Reading text data is really easy in BASIC!

As set up, the program reads a file called "hello.txt" located in the same directory as the program source code. It prints the file out, and also counts how many bytes it has read. At the end, it prints the size of the file.

Communication with the host PC is done using the 9P file system protocol, running over the serial line. This is naturally fairly slow, so you'll want to set the baud rate as high as your system will allow.

### Step-by-step guide

Open up FlexProp. Use File > Open File... to navigate to the directory holding the source code, and open typeit.bas. Press the "Compile & Run on P2" button. The "Propeller Output" window will open up and you'll see something like:
```
( Entering terminal mode.  Press Ctrl-] to exit. )
reading data:
Well, "Hello" there!
This is a text file I'm trying out.
Hope you enjoy reading it.
done: read 84 bytes
```
Close the propeller output window when you're done reading the message.

You may use any text editor to create/edit the hello.txt file. To change the "hello.txt" file from within FlexProp, use File > Open File..., and type "hello.txt" (without the quote marks) into the file name line (or change "Files of type" to read "All" and select it from the dialog box). Edit it as you wish, then go back to the typeit.bas tab and re-run.

### Using a different text file

To use a different file, just change the name in the typeit.bas source code. Where it reads:
```
open "/data/hello.txt" for input as #3
```
you could change it to:
```
open "/data/typeit.bas" for input as #3
```
to read the typeit.bas source code itself. Or put any other file name there. The file does have to be in the same directory as the typeit.bas file (for security reasons the file server built in to FlexProp only allows access to the directory that the program is running from).

If your text file is large, you may want to change the baud rate by selecting a higher speed under Ports> if you haven't already done so.

### Using an SD card instead

Changing the program to read from an SD card is very simple: just change the line that reads
```
  mount "/data", _vfs_open_host()
```
to
```
  mount "/data", _vfs_open_sdcard()
```
(and make sure you have an SD card with a file named "hello.txt" plugged in!)

## Parts Used

P2 Eval board. (Probably any P2 board would work, actually!)

## Source Code

See attached.

## Programming Language

FlexBASIC

## Tools and Operating System

FlexProp (for Windows, Mac OS, or Linux)

