'
' Simple BASIC program to type a user's text file
'

' baud rate definition is normally given to us on the FlexProp command line
' if for some reason it is not, use a default
#ifndef _BAUD
#define _BAUD 230400
#endif

' declare some variables
dim x$ as string   ' variable to hold the user data
dim err as integer ' variable to hold any error code
dim size as integer ' variable to hold the number of bytes read

' set up the baud rate
_setbaud(_BAUD)

' clear the count of characters read
size = 0

try

' first, mount a file system at mount point "/data"
  ' we chose to use the host's file system, but we could also
  ' use an SD card by using _vfs_open_sdcard() instead of
  ' _vfs_open_host()
  
  mount "/data", _vfs_open_host()

  ' now open hello.txt for input, using handle 3
  open "/data/hello.txt" for input as #3

  ' if an error happened, it'll be thrown and caught below
  print "reading data:"
  do
    ' read up to 80 characters from handle #3
    x$ = input$(80, 3)
    
    ' at end of file we will read an empty string
    if x$ = "" then
      exit do
    end if

    ' record how many bytes we read
    size += len(x$)
    
    ' print what we read; no need for a newline, so end with ;
    print x$;
  loop

catch err

' we come here if any error happened above
  ' the numeric error code is captured in `err`
  ' we can print a human readable version of that with strerror$
  print "An error occured: "; strerror$(err)
  
end try

print "done: read "; size; " bytes"
